<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * @category     :  ParsPal
 * @package      :  ParsPal_ParspalPayment
 *
 * @company      :  ParsPal
 * @created by   :  ParsPal Development Team
 * @contact      :  https://developer.parspal.com
 * @created on   :  June 2019
 * @author       :  ParsPal Development Team
 * @description  :  Parspal Gateway Payment for the component (Magento)
 */
class ParsPal_Parspal_Block_Info extends Mage_Payment_Block_Info
{
    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('parspal/info.phtml');
    }

    public function getMethodCode()
    {
        return $this->getInfo()->getMethodInstance()->getCode();
    }

    protected function _toHtml()
    {
        $msg = $this->getMethod()->getTitle() . '<br/>';
        if ($this->getInfo()->getLastTransId() != '') {
            $msg .= $this->__('Transaction Trace Number : %s', $this->htmlEscape($this->getInfo()->getLastTransId())) . '<br/>';
        }
        return $msg;
    }

    public function toPdf()
    {
        $this->setTemplate('parspal/pdf/info.phtml');
        return $this->toHtml();
    }
}