<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * @category     :  ParsPal
 * @package      :  ParsPal_ParspalPayment
 *
 * @company      :  ParsPal
 * @created by   :  ParsPal Development Team
 * @contact      :  https://developer.parspal.com
 * @created on   :  June 2019
 * @author       :  ParsPal Development Team
 * @description  :  Parspal Gateway Payment for the component (Magento)
 */
class ParsPal_Parspal_Block_Redirect extends Mage_Core_Block_Template
{
    /**
     * Return checkout session instance
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }

    /**
     * Return order instance
     *
     * @return Mage_Sales_Model_Order|null
     */
    protected function _getOrder()
    {
        if ($this->getOrder()) {
            return $this->getOrder();
        } elseif ($orderIncrementId = $this->_getCheckout()->getLastRealOrderId()) {
            return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
        } else {
            return null;
        }
    }

	public function getFormData()
	{
		@session_start();
		$order = $this->_getOrder()->_data;
		$array = $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
		$address = $this->_getOrder()->getShippingAddress();
		$callBackUrl = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_LINK) . 'parspal/processing/response/';
		require_once(dirname(dirname(__FILE__)) . '/parspal_payment_helper.class.php');
		$p = new Parspal_Payment_Helper($this->_getOrder()->getPayment()->getMethodInstance()->getConfigData('seller_id'));
		$r = $p->paymentRequest(array(
				'amount'      => intval(ceil($order["grand_total"])),
				'order_id'    => $order["entity_id"],
				'reserve_id'  => $order["increment_id"],
				'description' => 'MAGE-Order#'.$order["entity_id"],
				'return_url'  => $callBackUrl,
				'payer'       => array(
				'name'        => @$order['customer_firstname'].' '.@$order['customer_lastname'],
				'email'       => @$order['customer_email'],
				'mobile'      => @$address->getTelephone(),
			)));
		if ($r)
		{
			return array(true, $p->gatewayUrl);
		}
		else
		{
			return array(false, $p->error);
		}
    }
}
