<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * @category     :  ParsPal
 * @package      :  ParsPal_ParspalPayment
 *
 * @company      :  ParsPal
 * @created by   :  ParsPal Development Team
 * @contact      :  https://developer.parspal.com
 * @created on   :  June 2019
 * @author       :  ParsPal Development Team
 * @description  :  Parspal Gateway Payment for the component (Magento)
 */
class ParsPal_Parspal_ProcessingController extends Mage_Core_Controller_Front_Action
{
    protected $_successBlockType  = 'parspal/success';
    protected $_failureBlockType  = 'parspal/failure';

    protected $_order = NULL;
    protected $_paymentInst = NULL;


    /**
     * Get singleton of Checkout Session Model
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }
	public function mkzero($z){
		$str = "1";
		while($z > 0){
			$str .= "0";
			$z -= 1;
		}
		return $str;	
	} 
    public function redirectAction()
    {
        try {
            $session = $this->_getCheckout();

            $order = Mage::getModel('sales/order');
            $order->loadByIncrementId($session->getLastRealOrderId());
            if (!$order->getId()) {
                Mage::throwException('No order for processing found');
            }
            if ($order->getState() != Mage_Sales_Model_Order::STATE_PENDING_PAYMENT) {
                $order->setState(
                    Mage_Sales_Model_Order::STATE_PENDING_PAYMENT,
                    $this->_getPendingPaymentStatus(),
                    Mage::helper('parspal')->__('Customer was redirected to parspal gateway.')
                )->save();
            }

            if ($session->getQuoteId() && $session->getLastSuccessQuoteId()) {
                $session->setClickandbuyQuoteId($session->getQuoteId());
                $session->setClickandbuySuccessQuoteId($session->getLastSuccessQuoteId());
                $session->setClickandbuyRealOrderId($session->getLastRealOrderId());
                $session->getQuote()->setIsActive(false)->save();
                $session->clear();
            }

            $this->loadLayout();
            $this->renderLayout();
            return;
        } catch (Mage_Core_Exception $e) {
            $this->_getCheckout()->addError($e->getMessage());
        } catch(Exception $e) {
            Mage::logException($e);
        }
		
		
        //$this->_redirect('checkout/cart');
    }
	public function responseAction()
	{
		@session_start();
		$session = $this->_getCheckout();
		//$orderid = $session->getParspalPaymentRealOrderId();
		//$orderid = $session->getLastRealOrderId();
		$orderid = $session->getClickandbuyRealOrderId(); //???
		$this->_order = Mage::getModel('sales/order')->loadByIncrementId($orderid);
		$this->_paymentInst = $this->_order->getPayment()->getMethodInstance();
		$quote = $this->_order->getData();
		require_once(dirname(dirname(__FILE__)) . '/parspal_payment_helper.class.php');
		$p = new Parspal_Payment_Helper($this->_paymentInst->getConfigData('seller_id'));
		$r = $p->paymentVerify($_POST, intval(ceil($quote["grand_total"])));
		if ($r)
		{
			$message = "Payment Completed. OrderId : {$orderid} . PaymentRefrenceId : {$p->txn_id}";
			$this->_order->getPayment()->setTransactionId($p->txn_id);
			$this->_order->getPayment()->setLastTransId($p->txn_id);
			// create invoice
			if ($this->_order->canInvoice())
			{
				$invoice = $this->_order->prepareInvoice();
				$invoice->register()->capture();
				Mage::getModel('core/resource_transaction')
					->addObject($invoice)
					->addObject($invoice->getOrder())
					->save();
			}
			// add order history comment
			$message = sprintf($this->__("Yours order track number is %s"),$p->txn_id);
			$this->_order->addStatusToHistory($this->_paymentInst->getConfigData('order_status'), Mage::helper('parspal')->__('Payment complete'));
			$this->_order->addStatusToHistory($this->_paymentInst->getConfigData('order_status'), $message, true );
			// send email
			$this->_order->sendNewOrderEmail();
			$this->_order->setEmailSent(true);	
			$this->_order->save();
			Mage::getSingleton('core/session')->addSuccess($message);
			// redirect to success page
			$this->getResponse()->setBody(
				$this->getLayout()
					->createBlock($this->_successBlockType)
					->setOrder($this->_order)
					->toHtml());
		}
		else
		{
			$message = $p->error;
			$this->_redirect('parspal/processing/caberror');
			die ('ParsPal Error: '.$message);
		}
	}

    public function successAction()
    {
        try {
            $session = $this->_getCheckout();
            $session->unsClickandbuyRealOrderId();
            $session->setQuoteId($session->getClickandbuyQuoteId(true));
            $session->setLastSuccessQuoteId($session->getClickandbuySuccessQuoteId(true));
            $this->_redirect('checkout/onepage/success');
            return;
        } catch (Mage_Core_Exception $e) {
            $this->_getCheckout()->addError($e->getMessage());
        } catch(Exception $e) {
            Mage::logException($e);
        }
        $this->_redirect('checkout/cart');
    }

    /**
     * ClickandBuy sub error action
     */
    public function caberrorAction()
    {
        // set quote to active
        $session = $this->_getCheckout();
        if ($quoteId = $session->getClickandbuyQuoteId()) {
            $quote = Mage::getModel('sales/quote')->load($quoteId);
            if ($quote->getId()) {
                $quote->setIsActive(true)->save();
                $session->setQuoteId($quoteId);
            }
        }

        $this->getResponse()->setBody(
            $this->getLayout()
                ->createBlock($this->_failureBlockType)
                ->setOrder($this->_order)
                ->toHtml()
        );
    }

	/**
	 * ClickandBuy sub success action
	 */
	public function cabsuccessAction()
	{
		$this->caberrorAction();
	}

    /**
     * Checking GET and SERVER variables.
     * Creating invoice if payment was successfull or cancel order if payment was declined
     */
    protected function _checkReturnedParams()
    {
      return true;
    }

    protected function _getPendingPaymentStatus()
    {
        return Mage::helper('parspal')->getPendingPaymentStatus();
    }
}
